## simde 0.7.6

=== debian/changelog ===
simde (0.7.6-1) unstable; urgency=medium

  * Upload 0.7.6-1 to 'unstable'.
  * Document upstream source for ppc64el_fixes patch.

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 13 Jun 2023 12:05:05 +0200

simde (0.7.6-0~0exp3) experimental; urgency=medium

  * Install the pkg-config simde file in /usr/share/pkgconfig/,
    not /usr/lib/<triplet>/pkgconfig/
  * Autopkgtests: resume skipping some tests:
     i386: avx512/dbsad
     ppc64el: all tests pass
     s390x: all tests pass
  * d/rules: clean all the build directories
  * d/rules: save testing time by skipping 'emul' tests
  * Add another patch from upstream to fix ppc64el implementations of WASM
    SIMD128 functions.
  * pkg-config: drop "-Wno-psabi", too invasive

 -- Michael R. Crusoe <crusoe@debian.org>  Sat, 20 May 2023 09:32:48 +0200

simde (0.7.6-0~0exp2) experimental; urgency=medium

  * Autopkgtests control: use "@" so we get the same version of the
    package the test is written for

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 19 May 2023 22:17:19 +0200

simde (0.7.6-0~0exp1) experimental; urgency=medium

  * Standalone test: use pkg-config
  * pkg-config: Add "-Wno-psabi" (fixes standalone test for i386)
                Don't pass "-O3" (even though we really recommend it)

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 19 May 2023 00:23:30 +0200

simde (0.7.6-0~0exp0) experimental; urgency=medium

  * New upstream version
  * debian/test/standalone: Add standalone test from Homebrew
  * Removed debian/install and -override_dh_auto_install, use meson to
    install
  * Patch pkg-config to automatically include the optimizaton CFLAGS:
    "-DSIMDE_ENABLE_OPENMP -fopenmp-simd -O3"
  * Added patch to fix tests on ppc64el

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 16 May 2023 19:06:25 +0200

simde (0.7.4+really0.7.4-0exp0) experimental; urgency=medium

  * Whoops, meant to upload to experimental. Try #2

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 05 May 2023 14:51:13 +0200

=== debian/rules ===
#!/usr/bin/make -f

# DH_VERBOSE := 1
export LC_ALL=C.UTF-8

CLANG_SKIP=i386 alpha hppa ia64 m68k sh4 x32
# i386 is due to https://github.com/simd-everywhere/simde/issues/683
# ppc64 is due to https://github.com/simd-everywhere/simde/issues/185

include /usr/share/dpkg/default.mk
export DEB_BUILD_MAINT_OPTIONS=hardening=+all

ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
  export DEB_LDFLAGS_MAINT_APPEND=-latomic
endif
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
  export DEB_CFLAGS_MAINT_APPEND=-O0
  export DEB_CXXFLAGS_MAINT_APPEND=-O0
endif

%:
	dh $@ --buildsystem=meson+ninja

override_dh_auto_configure:
	dh_auto_configure -- -Dtests=false --libdir=lib
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
  # ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	# CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
  # endif
# https://github.com/simd-everywhere/simde/issues/867
ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
	sed -i "/'dbsad'/d" meson.build
	rm -f test/x86/avx512/dbsad.c
endif
# According to https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
# It is odd that gcc doesn't include this automatically, but clang does
ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64))
	export DEB_CFLAGS_MAINT_APPEND=-maltivec
	export DEB_CXXFLAGS_MAINT_APPEND=-maltivec
endif
	CC=gcc CXX=g++ dh_auto_configure --builddirectory=gcc_test
endif

override_dh_auto_build:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_build --builddirectory=gcc_test
  # ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
	# dh_auto_build --builddirectory=clang_test
  # endif
endif

override_dh_auto_test:
ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
	dh_auto_test --builddirectory=gcc_test -- $(shell meson test -C gcc_test --list | grep -v emul)
# Skip testing on clang for now owing to bug report #1002223
#  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
#	dh_auto_test --builddirectory=clang_test -- $(shell meson test -C clang_test --list | grep -v emul)
#  endif
endif

override_dh_auto_clean:
	dh_auto_clean --builddirectory=gcc_test
	dh_auto_clean --builddirectory=clang_test
	dh_auto_clean

override_dh_auto_install:
	dh_auto_install
	mkdir --parents debian/libsimde-dev/usr/share/
	mv debian/libsimde-dev/usr/lib/pkgconfig debian/libsimde-dev/usr/share/
	find debian/libsimde-dev -type d -empty -delete

## simde 0.8.0~rc1

=== debian/changelog ===
simde (0.8.0~rc1-1~0exp0) experimental; urgency=medium

  * New upstream version
  * d/patches: remove wasm_f64x2_pmin_altivec.patch & ppc64el_fixes,
    they were applied upstream.
  * d/control: switch to Architecture:any for wider testing
  * d/rules,tests/run-unit-test: try running the avx512 dbsad tests on
    i386 again.

 -- Michael R. Crusoe <crusoe@debian.org>  Mon, 20 Nov 2023 18:44:06 +0100

=== debian/rules ===
--- 
+++ 
@@ -28,10 +28,10 @@
 	# CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
   # endif
 # https://github.com/simd-everywhere/simde/issues/867
-ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
-	sed -i "/'dbsad'/d" meson.build
-	rm -f test/x86/avx512/dbsad.c
-endif
+# ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
+# 	sed -i "/'dbsad'/d" meson.build
+# 	rm -f test/x86/avx512/dbsad.c
+# endif
 # According to https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
 # It is odd that gcc doesn't include this automatically, but clang does
 ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64))

## simde 0.8.2~rc1

=== test/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.0)

project(simde-tests)

set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake)
include (ExtraWarningFlags)

enable_testing()

option(BUILD_CPP_TESTS "Build C++ tests" ON)

if(NOT EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/munit/munit.c")
  find_program(GIT git)
  if(GIT)
    execute_process(COMMAND ${GIT} submodule update --init --recursive)
  else()
    message (FATAL_ERROR "It looks like you don't have submodules checked out.  Please run `git submodule update --init --recursive'")
  endif()
endif()

if(CMAKE_BUILD_TYPE STREQUAL "")
  set(CMAKE_BUILD_TYPE "Debug")
elseif(CMAKE_BUILD_TYPE STREQUAL "Coverage")
  set(orig_req_libs "${CMAKE_REQUIRED_LIBRARIES}")
  set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};--coverage")
  check_c_compiler_flag("--coverage" CFLAG___coverage)
  set(CMAKE_REQUIRED_LIBRARIES "${orig_req_libs}")

  if(CFLAG___coverage)
    set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} --coverage")
    set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_C_FLAGS} --coverage")
    add_definitions("-DSIMDE_NO_INLINE")
  else()
    set(CMAKE_BUILD_TYPE "Debug")
  endif()
endif()

add_library(munit STATIC munit/munit.c)

include(CheckSymbolExists)
check_symbol_exists(clock_gettime "time.h" CLOCK_GETTIME_RES)
if(CLOCK_GETTIME_RES)
  set(CLOCK_GETTIME_EXISTS yes)
else()
  set(orig_req_libs "${CMAKE_REQUIRED_LIBRARIES}")
  set(CMAKE_REQUIRED_LIBRARIES "${CMAKE_REQUIRED_LIBRARIES};rt")

  check_symbol_exists(clock_gettime "time.h" CLOCK_GETTIME_LIBRT_RES)
  if(CLOCK_GETTIME_LIBRT_RES)
    set(CLOCK_GETTIME_EXISTS yes)
    set(CLOCK_GETTIME_LIBRARY "rt")
  endif()

  set(CMAKE_REQUIRED_LIBRARIES "${orig_req_libs}")
  unset(orig_req_libs)
endif()

check_symbol_exists(fegetround "fenv.h" FEGETROUND_EXISTS)
if(NOT FEGETROUND_EXISTS)
  unset(FEGETROUND_EXISTS CACHE)
  list(APPEND CMAKE_REQUIRED_LIBRARIES m)
  check_symbol_exists(fegetround "fenv.h" FEGETROUND_EXISTS)
  if(FEGETROUND_EXISTS)
    set(NEED_LIBM True)
  else()
    message(FATAL_ERROR "Unable to find fegetround")
  endif()
endif(NOT FEGETROUND_EXISTS)

set_property(TARGET munit PROPERTY C_STANDARD "99")
if("${CLOCK_GETTIME_EXISTS}")
  target_compile_definitions(munit PRIVATE "MUNIT_ALLOW_CLOCK_GETTIME")
  target_link_libraries(munit "${CLOCK_GETTIME_LIBRARY}")
endif()

if("${OPENMP_SIMD_FLAGS}" STREQUAL "")
  foreach(omp_simd_flag "-fopenmp-simd" "-qopenmp-simd")
    string (REGEX REPLACE "[^a-zA-Z0-9]+" "_" omp_simd_flag_name "CFLAG_${omp_simd_flag}")
    check_c_compiler_flag("${omp_simd_flag}" "${omp_simd_flag_name}")

    if(${omp_simd_flag_name})
      set(OPENMP_SIMD_FLAGS "-DSIMDE_ENABLE_OPENMP ${omp_simd_flag}")
      break()
    endif()
  endforeach()
endif()

set(CMAKE_C_FLAGS "${CMAKE_C_FLAGS} ${OPENMP_SIMD_FLAGS}")

if("${CMAKE_C_COMPILER_ID}" STREQUAL "Intel")
  add_definitions(-DSIMDE_FAST_MATH)
endif()

include_directories("${CMAKE_CURRENT_BINARY_DIR}")

function(generate_declare_suites OUTFILE SOURCES)
  file(WRITE "${OUTFILE}" "")
  foreach(SOURCE ${SOURCES})
    get_filename_component(SUITE ${SOURCE} NAME_WLE)
    string(REPLACE "." "_" SUITE "${SUITE}")
    # message(FATAL_ERROR "${SUITE}")
    file(APPEND "${OUTFILE}" "SIMDE_TEST_DECLARE_SUITE(${SUITE})\n")
  endforeach(SOURCE ${SOURCES})
endfunction(generate_declare_suites)

aux_source_directory("arm/neon" ARM_NEON_SOURCES_C)
list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/run-tests.c")
list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/skel.c")
list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/skel-single.c")
list(REMOVE_ITEM ARM_NEON_SOURCES_C "arm/neon/skel-triple.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/arm/neon/declare-suites.h" "${ARM_NEON_SOURCES_C}")

aux_source_directory("arm/sve" ARM_SVE_SOURCES_C)
list(REMOVE_ITEM ARM_SVE_SOURCES_C "arm/sve/run-tests.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/arm/sve/declare-suites.h" "${ARM_SVE_SOURCES_C}")

aux_source_directory("x86/avx512" X86_AVX512_SOURCES_C)
list(REMOVE_ITEM X86_AVX512_SOURCES_C "x86/avx512/run-tests.c")
list(REMOVE_ITEM X86_AVX512_SOURCES_C "x86/avx512/skel.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/x86/avx512/declare-suites.h" "${X86_AVX512_SOURCES_C}")

aux_source_directory("x86" X86_SOURCES_C)
list(REMOVE_ITEM X86_SOURCES_C "x86/skel.c")
list(REMOVE_ITEM X86_SOURCES_C "x86/run-tests.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/x86/declare-suites.h" "${X86_SOURCES_C}")

aux_source_directory("wasm/simd128" WASM_SIMD128_SOURCES_C)
list(REMOVE_ITEM WASM_SIMD128_SOURCES_C "wasm/simd128/run-tests.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/wasm/simd128/declare-suites.h" "${WASM_SIMD128_SOURCES_C}")

aux_source_directory("wasm/relaxed-simd" WASM_RELAXED_SIMD_SOURCES_C)
list(REMOVE_ITEM WASM_RELAXED_SIMD_SOURCES_C "wasm/relaxed-simd/run-tests.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/wasm/relaxed-simd/declare-suites.h" "${WASM_RELAXED_SIMD_SOURCES_C}")

aux_source_directory("mips/msa" MIPS_MSA_SOURCES_C)
list(REMOVE_ITEM MIPS_MSA_SOURCES_C "mips/msa/run-tests.c")
generate_declare_suites("${CMAKE_CURRENT_BINARY_DIR}/test/mips/msa/declare-suites.h" "${MIPS_MSA_SOURCES_C}")

set(TEST_SOURCES_C
  ${X86_SOURCES_C}
  ${X86_AVX512_SOURCES_C}
  ${ARM_NEON_SOURCES_C}
  ${ARM_SVE_SOURCES_C}
  ${WASM_SIMD128_SOURCES_C}
  ${WASM_RELAXED_SIMD_SOURCES_C}
  ${MIPS_MSA_SOURCES_C})

set(TEST_RUNNER_SOURCES
  run-tests.c
  x86/run-tests.c
  x86/avx512/run-tests.c
  arm/run-tests.c
  arm/neon/run-tests.c
  arm/sve/run-tests.c
  wasm/run-tests.c
  wasm/simd128/run-tests.c
  wasm/relaxed-simd/run-tests.c
  mips/run-tests.c
  mips/msa/run-tests.c)
add_executable(run-tests ${TEST_RUNNER_SOURCES})
set_property(TARGET run-tests PROPERTY C_STANDARD "99")
target_add_compiler_flags(run-tests "-Wno-psabi")

target_link_libraries(run-tests munit)
target_add_compiler_flags (munit "-w")
if(NEED_LIBM)
  target_link_libraries(run-tests m)
endif(NEED_LIBM)

set(TEST_SOURCES_CPP)
if(BUILD_CPP_TESTS)
  foreach(csource ${TEST_SOURCES_C})
    configure_file("${csource}" "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp")
    list(APPEND TEST_SOURCES_CPP "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp")

    get_filename_component(DIR "${csource}" DIRECTORY)
    set_property(SOURCE "${CMAKE_CURRENT_BINARY_DIR}/${csource}pp" APPEND PROPERTY COMPILE_FLAGS " -I${CMAKE_CURRENT_SOURCE_DIR}/${DIR}")
  endforeach()

  add_definitions(-DSIMDE_BUILD_CPP_TESTS)
endif(BUILD_CPP_TESTS)

add_definitions(-DSIMDE_CONSTRAINED_COMPILATION)

foreach(native native emul)
  add_library(simde-test-${native} STATIC ${TEST_SOURCES_C} ${TEST_SOURCES_CPP})

  target_include_directories(simde-test-${native} PRIVATE "${CMAKE_CURRENT_SOURCE_DIR}/..")
  set_property(TARGET simde-test-${native} PROPERTY C_STANDARD "99")

  target_link_libraries(run-tests simde-test-${native})
  target_add_compiler_flags(simde-test-${native} "-Wno-psabi")
endforeach(native native emul)
target_compile_definitions(simde-test-emul PRIVATE SIMDE_NO_NATIVE)

foreach(src ${TEST_SOURCES_C})
  string(REGEX REPLACE "^(.+)\\.c$" "/\\1" TEST_NAME "${src}")
  add_test(NAME "${TEST_NAME}" COMMAND $<TARGET_FILE:run-tests> "${TEST_NAME}")
endforeach(src ${TEST_SOURCES_C})

message(WARNING
        "CMake support is deprecated; please use Meson instead.  CMake is only present "
        "for compilers which Meson doesn't yet support (e.g., xlc) and platforms where "
        "difficult to run an up-to-date copy of Meson (e.g., Ubuntu 12.04).")

=== debian/changelog ===
simde (0.8.2~rc1-1) experimental; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Tue, 30 Apr 2024 18:47:29 +0200

simde (0.8.0~rc2-1~0exp0) experimental; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 07 Mar 2024 15:19:08 +0100

=== debian/control ===
Source: simde
Maintainer: Debian Med Packaging Team <debian-med-packaging@lists.alioth.debian.org>
Uploaders: Michael R. Crusoe <crusoe@debian.org>
Section: libdevel
Priority: optional
Build-Depends: debhelper-compat (= 13),
               meson,
               ninja-build
#              clang [!i386 !alpha !hppa !ia64 !kfreebsd-amd64 !kfreebsd-i386 !m68k !sh4 !x32] <!nocheck>
Standards-Version: 4.6.2
Vcs-Browser: https://salsa.debian.org/med-team/simde
Vcs-Git: https://salsa.debian.org/med-team/simde.git
Homepage: https://github.com/simd-everywhere/simde
Rules-Requires-Root: no

Package: libsimde-dev
Architecture: any
Multi-Arch: foreign
Depends: ${misc:Depends}
Description: Implementations of SIMD instructions for all systems
 SIMDe provides fast, portable implementations of SIMD intrinsics on hardware
 which doesn't natively support them, such as calling SSE functions on ARM.
 There is no performance penalty if the hardware supports the native
 implementation (e.g., SSE/AVX runs at full speed on x86, NEON on ARM, etc.).
 .
 This makes porting code to other architectures much easier in a few key ways:
 .
 First, instead of forcing you to rewrite everything for each architecture,
 SIMDe lets you get a port up and running almost effortlessly. You can then
 start working on switching the most performance-critical sections to native
 intrinsics, improving performance gradually. SIMDe lets (for example) SSE/AVX
 and NEON code exist side-by-side, in the same implementation.
 .
 Second, SIMDe makes it easier to write code targeting ISA extensions you don't
 have convenient access to. You can run NEON code on your x86 machine without an
 emulator. Obviously you'll eventually want to test on the actual hardware
 you're targeting, but for most development, SIMDe can provide a much easier
 path.
 .
 SIMDe takes a very different approach from most other SIMD abstraction layers
 in that it aims to expose the entire functionality of the underlying
 instruction set. Instead of limiting functionality to the lowest common
 denominator, SIMDe tries to minimize the amount of effort required to port
 while still allowing you the space to optimize as needed.
 .
 The current focus is on writing complete portable implementations, though a
 large number of functions already have accelerated implementations using one
 (or more) of the following:
 .
     SIMD intrinsics from other ISA extensions (e.g., using NEON to implement
 SSE).
     Compiler-specific vector extensions and built-ins such as
 __builtin_shufflevector and __builtin_convertvector
     Compiler auto-vectorization hints, using:
        OpenMP 4 SIMD
        Cilk Plus
        GCC loop-specific pragmas
        clang pragma loop hint directives

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,10 @@
 ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
   export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
-ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
-  export DEB_CFLAGS_MAINT_APPEND=-O0
-  export DEB_CXXFLAGS_MAINT_APPEND=-O0
-endif
+# ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
+#   export DEB_CFLAGS_MAINT_APPEND=-O0
+#   export DEB_CXXFLAGS_MAINT_APPEND=-O0
+# endif
 
 %:
 	dh $@ --buildsystem=meson+ninja

## simde 0.8.2

=== debian/changelog ===
simde (0.8.2-3) unstable; urgency=medium

  * Team upload.
  [ zhangdandan <zhangdandan@loongson.cn> ]
  * Apply upstream PR: #1287 to fix another loongarch64 related failure of
    reverse-dependencies (Closes: #1100017)

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Mon, 10 Mar 2025 23:01:38 +0100

simde (0.8.2-2) unstable; urgency=medium

  * Team upload.

  [ Dandan Zhang ]
  * x86/sse.h: Fix type convert error for LSX.
    - Applied-Upstream: master, https://github.com/simd-everywhere/simde/pull/1215
  * x86/sse2.h: Add LSX support for sse2.h.
    - Applied-Upstream: master, https://github.com/simd-everywhere/simde/pull/1236
      (Closes: #1088545)
 
 -- Gianfranco Costamagna <locutusofborg@debian.org>  Sat, 30 Nov 2024 09:55:14 +0100

simde (0.8.2-1) unstable; urgency=medium

  * New upstream version

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 02 May 2024 13:04:35 +0200

simde (0.8.0-1) unstable; urgency=medium

  * New upstream version
  * drop two patches that were cherry-picked from upstream:
    ppc64el_fixes & wasm_f64x2_pmin_altivec.
  * Skip fpclass tests on i386.

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 14 Mar 2024 14:31:07 +0100

=== debian/control ===
--- 
+++ 
@@ -14,7 +14,7 @@
 Rules-Requires-Root: no
 
 Package: libsimde-dev
-Architecture: any
+Architecture: all
 Multi-Arch: foreign
 Depends: ${misc:Depends}
 Description: Implementations of SIMD instructions for all systems

=== debian/tests/control ===
Tests: standalone
Depends: @, gcc, g++, pkgconf, dpkg-dev

Tests: run-unit-test
Depends: @, gcc, g++, meson, ninja-build, dpkg-dev
Restrictions: allow-stderr

## simde 0.8.4~rc2

=== debian/changelog ===
simde (0.8.4~rc2-1) unstable; urgency=medium

  * d/watch: upgrade to version 5
  * New upstream version
  * Standards-Version: 4.7.3 (routine-update)
  * Remove trailing whitespace in debian/changelog (routine-update)
  * Removed three patches applied upstream.
  * Cherry-pick patch from upstream to fix test error with dpkg-
    buildflags.

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 22 Feb 2026 11:07:15 +0100

## simde 0.8.4~rc3

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)

project(
    simde
    DESCRIPTION
        "Implementations of SIMD instruction sets for systems which don't natively support them."
    HOMEPAGE_URL "https://github.com/simd-everywhere/simde"
    LANGUAGES C CXX
    VERSION 0.8.4
)

# Options
option(SIMDE_TEST_CMAKE_PACKAGING "Test cmake packaging" ${PROJECT_IS_TOP_LEVEL})

# The main simde library
add_library(simde INTERFACE)
add_library(simde::simde ALIAS simde)

target_compile_features(simde INTERFACE c_std_99)

target_include_directories(
    simde
    INTERFACE
        $<BUILD_INTERFACE:${CMAKE_CURRENT_SOURCE_DIR}>
        $<INSTALL_INTERFACE:include>
)

if(SIMDE_TEST_CMAKE_PACKAGING)
    include(CTest)
    enable_testing()
    add_subdirectory(test/cmake-packaging)
endif()

include(GNUInstallDirs)

# Install headers
install(DIRECTORY simde DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})

# Export targets
install(TARGETS simde EXPORT simde-targets)

# Package Configuration
include(CMakePackageConfigHelpers)

write_basic_package_version_file(
    ${CMAKE_CURRENT_BINARY_DIR}/simde-config-version.cmake
    VERSION ${PROJECT_VERSION}
    COMPATIBILITY SameMajorVersion
)

file(
    WRITE
    ${CMAKE_CURRENT_BINARY_DIR}/simde-config.cmake.in
    "@PACKAGE_INIT@\n"
    "include(\"\${CMAKE_CURRENT_LIST_DIR}/simde-config-targets.cmake\")\n"
)

configure_package_config_file(
    ${CMAKE_CURRENT_BINARY_DIR}/simde-config.cmake.in
    ${CMAKE_CURRENT_BINARY_DIR}/simde-config.cmake
    INSTALL_DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/simde
    NO_SET_AND_CHECK_MACRO
    NO_CHECK_REQUIRED_COMPONENTS_MACRO
)

install(
    FILES
        ${CMAKE_CURRENT_BINARY_DIR}/simde-config.cmake
        ${CMAKE_CURRENT_BINARY_DIR}/simde-config-version.cmake
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/simde
)

install(
    EXPORT simde-targets
    FILE simde-config-targets.cmake
    NAMESPACE simde::
    DESTINATION ${CMAKE_INSTALL_LIBDIR}/cmake/simde
)

=== test/cmake-packaging/CMakeLists.txt ===
add_test(
    NAME simde-cmake-install
    COMMAND ${CMAKE_CTEST_COMMAND}
        --build-and-test "${PROJECT_SOURCE_DIR}"
                         "${PROJECT_BINARY_DIR}/build"
        --build-generator ${CMAKE_GENERATOR}
        --build-target install
        --build-options "-DCMAKE_INSTALL_PREFIX=${PROJECT_BINARY_DIR}/install"
)

add_test(
    NAME simde-cmake-find-package
    COMMAND ${CMAKE_CTEST_COMMAND}
    --build-and-test "${CMAKE_CURRENT_SOURCE_DIR}/cmake-find-package"
                     "${PROJECT_BINARY_DIR}/cmake-find-package/build"
    --build-generator "${CMAKE_GENERATOR}"
    --build-options "-DCMAKE_PREFIX_PATH=${PROJECT_BINARY_DIR}/install"
)
set_tests_properties(simde-cmake-find-package PROPERTIES DEPENDS simde-cmake-install)

add_test(
    NAME simde-cmake-fetchcontent
    COMMAND ${CMAKE_CTEST_COMMAND}
    --build-and-test "${CMAKE_CURRENT_SOURCE_DIR}/cmake-fetchcontent"
                     "${PROJECT_BINARY_DIR}/cmake-fetchcontent/build"
    --build-generator "${CMAKE_GENERATOR}"
)

=== test/cmake-packaging/cmake-fetchcontent/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(simde-fetchcontent-consumer LANGUAGES C CXX)

include(FetchContent)
FetchContent_Declare(simde SOURCE_DIR ${CMAKE_CURRENT_SOURCE_DIR}/../../../)
FetchContent_MakeAvailable(simde)

add_executable(consumer-fc-c main.c)
target_link_libraries(consumer-fc-c PRIVATE simde::simde)

add_executable(consumer-fc-cpp main.cpp)
target_link_libraries(consumer-fc-cpp PRIVATE simde::simde)

enable_testing()
add_test(NAME consumer-fc-c COMMAND consumer-fc-c)
add_test(NAME consumer-fc-cpp COMMAND consumer-fc-cpp)

=== test/cmake-packaging/cmake-find-package/CMakeLists.txt ===
cmake_minimum_required(VERSION 3.22)
project(simde-consumer LANGUAGES C CXX)

find_package(simde CONFIG REQUIRED)
message(STATUS "simde version: ${simde_VERSION}")

add_executable(consumer-c main.c)
target_link_libraries(consumer-c PRIVATE simde::simde)

add_executable(consumer-cpp main.cpp)
target_link_libraries(consumer-cpp PRIVATE simde::simde)

enable_testing()
add_test(NAME consumer-c COMMAND consumer-c)
add_test(NAME consumer-cpp COMMAND consumer-cpp)

=== debian/changelog ===
simde (0.8.4~rc3-3) unstable; urgency=medium

  * d/tests: fix risc64→riscv6 typo.

 -- Michael R. Crusoe <crusoe@debian.org>  Fri, 27 Feb 2026 13:58:01 +0100

simde (0.8.4~rc3-2) unstable; urgency=medium

  * d/tests: skip emulated tests on riscv64, to avoid timeout

 -- Michael R. Crusoe <crusoe@debian.org>  Thu, 26 Feb 2026 17:12:21 +0100

simde (0.8.4~rc3-1) unstable; urgency=medium

  * tests: also run the emulated tests
  * New upstream version
  * Drop patch applied upstream.

 -- Michael R. Crusoe <crusoe@debian.org>  Sun, 22 Feb 2026 18:11:37 +0100

=== debian/rules ===
--- 
+++ 
@@ -13,10 +13,10 @@
 ifneq (,$(filter $(DEB_BUILD_ARCH),armel))
   export DEB_LDFLAGS_MAINT_APPEND=-latomic
 endif
-# ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
-#   export DEB_CFLAGS_MAINT_APPEND=-O0
-#   export DEB_CXXFLAGS_MAINT_APPEND=-O0
-# endif
+ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
+  export DEB_CFLAGS_MAINT_APPEND=-O0
+  export DEB_CXXFLAGS_MAINT_APPEND=-O0
+endif
 
 %:
 	dh $@ --buildsystem=meson+ninja
@@ -28,10 +28,12 @@
 	# CC=clang CXX=clang++ dh_auto_configure --builddirectory=clang_test
   # endif
 # https://github.com/simd-everywhere/simde/issues/867
-# ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
-# 	sed -i "/'dbsad'/d" meson.build
-# 	rm -f test/x86/avx512/dbsad.c
-# endif
+ifneq (,$(filter $(DEB_BUILD_ARCH),i386))
+	sed -i "/'dbsad'/d" meson.build
+	sed -i "/'fpclass'/d" meson.build
+	rm -f test/x86/avx512/dbsad.c
+	rm -f test/x86/avx512/fpclass.c
+endif
 # According to https://wiki.debian.org/ArchitectureSpecificsMemo#Architecture_baselines
 # It is odd that gcc doesn't include this automatically, but clang does
 ifneq (,$(filter $(DEB_BUILD_ARCH),ppc64))
@@ -51,10 +53,10 @@
 
 override_dh_auto_test:
 ifeq (,$(filter nocheck,$(DEB_BUILD_OPTIONS)))
-	dh_auto_test --builddirectory=gcc_test -- $(shell meson test -C gcc_test --list | grep -v emul)
+	dh_auto_test --builddirectory=gcc_test
 # Skip testing on clang for now owing to bug report #1002223
 #  ifeq (,$(filter $(DEB_HOST_ARCH),$(CLANG_SKIP)))
-#	dh_auto_test --builddirectory=clang_test -- $(shell meson test -C clang_test --list | grep -v emul)
+#	dh_auto_test --builddirectory=clang_test
 #  endif
 endif

=== debian/watch ===
Version: 5

Template: GitHub
Owner: simd-everywhere
Project: simde
Version-Type: SEMANTIC_VERSION
Uversion-Mangle: s/-rc-/~rc/; s/-rc/~rc/
